"""
K-means clustering method for Fast breaking measurements - Running script
@author: Damien Cabosat
Adapted by Alfredo Rates based in modifications from Beatrice Vollmer
October 2018
RUN EACH CELL, NOT ALL THE CODE
"""
import os
os.chdir('C:/Users/LocalAdmin/Desktop/v3')

# In[Kmeans parameters]
### Path
All_molecule = ['Test2']

All_import_path = [r"E:\Data\Piezo_setup\BINAPTHALENE_DITHIOL\Sample2\molecule\14-18"]  
#E:\Data\Piezo_setup\CyclophaneII\CP_no_metal_3\Molecule\13-17\scan200126_0
All_file_name = ['scan210726_48']  

All_labels = ['0']

Save_path = r""

### Importing parameters
breakingspeed = [200]
attenuation = [0.03/300]

### Interpolation
Vtodconversion = 0.3e-6
N_interpolation = [0,0]             # [N points for images, N points for 1D histo], 0 to not interpolate

### Clustering parameters
N_classes = 3

### Histogram parameters
xmin = -0.25 
xmax = 3.0
ymin = -7.0
ymax = 1
zmin = 0
zmax = 0.03

bins_1D = 100
xbins = 222
ybins = 150
    
### Purge parameters
Purge_limit = 5e-6

### Fitting parametersy
sigma = 3

## Manual fitting parameters
xmin_fit = -6.5
xmax_fit = -4.5
mean_init = -5.5
#xmin_fit = -3.5
#xmax_fit = -2.0
#mean_init = -2.7
amplitude_init = 30
sigma_init = 0.2

### Image parametersy
ybins_image = 32                    #4 per decade
xbins_image = 28                   #1 pixel per 0.1nm

### Booleans
Purge =             False            #Eliminate traces that does not reach the noise level
Fit_1D_raw =        False           #Fit the 1D histogram from raw data?
Include_1D =        False            #Include 1D histogram in the Clustering?
Separate_label =    False           #Analyse also classes separated by labels?
Fit_1D_class =      True            #Fit the 1D histogram for each class?
Warning_messages =  False           #Pause script to check progress?
Sound_alert =       False            #Activate sound alerts? (Yes! :D )
Save_dif_path =     False            #Save data in different path?
automatic_binning = True            # Calculate the binning automatically
Iterate_binning =   False            #Iterate 2D histogram from raw data to check binning
Iterate_N_classes = True            #Iteration Clustering to select number of classes
ManualFit =         True            #Fit the 1D histogram manually
Iterate_ManualFit = True            #Iterate the 1D manual fitting?
save_classes_info = False            #Save info from eac class in different files

exec(open("./Scripts/K_means_reduced.py").read())

# In[SubClasses parameters]
Class_to_split =0
N_subclasses = 3

Load =              False
B_fit =             True
Separate_label =    True
Warning_messages =  False
Include_1D =        True
Iterate_N_classes = True
Sound_alert =       True
ManualFit =         True
Iterate_ManualFit = True

if Load:
    molecule = 'Test1'
    import_path = r"E:\Data\Piezo_setup\BINAPTHALENE_DITHIOL\Sample2\molecule\14-18"
    file_name = 'scan210726_48'      
    import_path = import_path.replace("\\", "/")+'/'
    Add_str = ''
    N_points_interp = 0
    N_classes = 4

exec(open("./Scripts/Sub_classes.py").read())

# In[Merge classes parammeters]

Classes_to_merge = [0,2]

Load =              False
B_fit =             True
ManualFit =         True
Iterate_ManualFit = True
Separate_label =    True
Warning_messages =  False

## Manual fitting parameters
xmin_fit = -6
xmax_fit = -4
mean_init = -5.5

amplitude_init = 30
sigma_init = 0.2

if Load:
    print('Restoring files')
    molecule = 'P3'
    import_path = r"D:\alfredoratesso\Desktop\Molecular Electronics\Porphyrins\P3\Sample 1\3-7"
    file_name = 'scan180727_1'  
    import_path = import_path.replace("\\", "/")+'/'
    Add_str = ''
    N_points_interp = 8000
    N_classes = 3
    
exec(open("./Scripts/Merge_classes.py").read())

# In[Restore data]

#0 to redo Xtrain, 1 to redo Kmeans, 2 to redo classes, 3 to load everything:
Restoration_point = 3
#Save_dif_path = True

## Manual fitting parameters
xmin_fit = -5
xmax_fit = -2
mean_init = -3.5

amplitude_init = 30
sigma_init = 0.2

## Path
All_molecule = ['P3']
All_import_path = [r"D:\alfredoratesso\Desktop\Molecular Electronics\Porphyrins\P3\Sample 1\3-7"]  
All_file_name = ['scan180726_10']  
All_labels = ['1']
#Save_path = r"D:\alfredoratesso\Desktop\Molecular Electronics\Porphyrins\P3\new_code\restore"
All_Add_str = ['']
All_N_points_interp = [0]
N_classes = 3

Iterate_N_classes = True
Sound_alert =       True
Include_1D =        True
Warning_messages =  False
Fit_1D_class =      True
Separate_label =    False
ManualFit =         True
Iterate_ManualFit = True

exec(open("./Scripts/Restore_data.py").read())

# In[Biased parameters] $NOT COMPLETE
## Biased criteria
#Format: list with strings as criteria+operator+value.
#criteria can be: len (to separate based in length)
#                 con (to separate based in average conductance)
#                 slo (to separate based in average slope)
#operator can be: > and/or < (< is considered <=)
#value can be: int or float...
bias = ['len>1.2','len<4']

exec(open("./Scripts/K_means_biased.py").read())