function Fit_Length_1G0(G,Nplotted,plotstart,plotend,Xmax,Xmin,Xbin)

%% Fitting 1D and 1D_mol histograms and plotting them together with ipf
% Execute every section separately and follow the instructions in the
% comments
    G0Length = zeros(1,Nplotted);
    for i = plotstart:plotend
        try
            xstart = find((G(i).g_breaking)>10^0.3,1,'last');   % 10^0.15 = 1.4125
            xend = find((G(i).g_breaking)<10^-0.3,1,'first');     % 10^-0.15 = 0.7079 it is different than previously defined (3e-1) but makes effectively no difference
            G0Length(i) = (G(i).d_breaking(xend)-G(i).d_breaking(xstart));
        catch err
        end
    end
    G0Length = G0Length(G0Length~=0);
	 G0Lengthbins = -0.0:(Xmax-Xmin)/Xbin:2;
	 G0Lengthhisto = hist(G0Length,G0Lengthbins);
    G0Lengthhisto = G0Lengthhisto/Nplotted;
%     h = figure('Position',[300 150 1100 775],'PaperPositionMode','auto');
%     bar(G0Lengthbins,G0Lengthhisto);
%     title ('1G_0 length');
%     ylabel('Counts/Trace');
%     xlabel('Length [nm]');
%     set(gca,'Xlim',[0.05 1.0])
%     set(gca,'fontsize',26,'fontweight','normal')
%     set(findall(gcf,'type','text'),'fontsize',22,'fontweight','normal')
%     set(gca,'linewidth',2,'box','on')
%     set(gcf,'color','white')
%%
% ipf(G0Lengthbins,G0Lengthhisto)
signal=[G0Lengthbins' G0Lengthhisto'];
guess=[0.25,0.1];
%peakfit(signal,Window.center,Window.width,NumPeaks,Peakshape,extra,NumTrials,start,autozero,fixedparameters,plots)
[FitResults, FitError, Baseline] = peakfit(signal,0,0,1,1,0,3,guess,0,0,0);
%FitResults ->  PeakNumber  Position   Height     Width      PeakArea

% set(gcf,'Position',[300 150 1100 775],'PaperPositionMode','auto');

%%
% Fit however you want

%%
% saveas(gcf,[savepath filename '_G0_length_fit.png']);
% saveas(gcf,[savepath filename '_G0_length_fit.fig']);

%%
% Press w on the fit
% Fill in these
% Window.width=0.99497;  Window.center= 0.46734; NumPeaks = 1;
% Baseline = 0;
% Peakshape = 1;

%%
% Press r on the fit
% Fill in these
% FitResults = [1      0.22568     0.077305      0.34001      0.02686];

%%
	%Opens new window where to plot
%subplot(2,2,4)      %Plots in panel 4 of the subplot
Peakshape=1;
bar(G0Lengthbins,G0Lengthhisto,'Facecolor',[0.6445,0.8008,0.5352]);
title('G_0 length')
ylabel('Counts / trace');
xlabel('Length [nm]');
set(gca,'Xlim',[0 1])
set(gca,'Ylim',[0 1.05*max(G0Lengthhisto)])
set(gca,'fontsize',20,'fontweight','normal')
set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
set(gca,'linewidth',2,'box','on')
set(gcf,'color','white')
set(gca,'Tickdir','in')
hold on

if Peakshape == 1
    g=@(x,par)par(3)*exp(-((x-par(2))./(0.6005615.*par(4))) .^2);%gaussian
 elseif Peakshape == 2
    g=@(yplot,par) par(3)./(1+((yplot-par(2))./(0.5.*par(4))).^2);%lorenzian
 else
    disp('Peak shape not recognized');
end

%yplotfit=linspace(Window.center-Window.width/2,Window.center+Window.width/2,100);
yplotfit=linspace(0,5,500);
plot(yplotfit,g(yplotfit,FitResults(:)),'--','linewidth',2.0,'Color', [0.7148,0.1563,0.1797])
str1=sprintf('%0.2f',FitResults(2));
str2='$$\pm$$';
str3=sprintf('%0.2f nm',FitResults(4)/(2*sqrt(2*log(2))));
str=strcat(str1,str2,str3);
legend({'Plateau Displacement', str},'Interpreter','latex')
 

%%
% saveas(gcf,[savepath filename '_G0_length_fit result.png']);
% saveas(gcf,[savepath filename '_G0_length_fit result.eps'],'psc2');
end
