function plot_Junction_evo(trace_hist,yedges,Nfiles)
	if nargin<2
		yedges = evalin('base','yedges');
	end
	if nargin<3
		Nfiles = evalin('base','Nfiles');
	end
	tracenum = 1:Nfiles;
   Gmin=log10(min(yedges));
   Gmax=log10(max(yedges));

%J_evo is obsolete, trace_hist is ideally identical to J_evo (small
% differences due to the different filling method)
%	J_evo = zeros(Gbin,Nfiles);
%	for i = 1:Nfiles
%		J_evo(:,i) = hist(G{i}.g_breaking,yedges);
%	end
%    load('mycmap.mat')
	pos1 = find(min(abs(yedges - 3)) == abs(yedges - 3));
 	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
 	MAX = max(max(trace_hist(pos2:pos1,:)));

	surf(tracenum,yedges,trace_hist,'LineStyle','none');	% 'LineStyle','none' removes the grid over which the surface is plotted, preventing the plot to show as all black when too dense
	set(gca,'YScale','log')
	view([0 90])
	xlabel('Trace number');
	ylabel('Conductance [G_0]');
	set(gca,'fontsize',22,'fontweight','normal')
	set(findall(gcf,'type','text'),'fontsize',22,'fontweight','normal')
	set(gca,'linewidth',0.5,'box','on')
	set(gcf,'color','white')
	set(gca,'Xlim',[1 Nfiles])
	set(gca,'Ylim',[10^Gmin 3])
	set(gca,'YTick',[1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
% 	set(gca,'YTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
	set(gca,'Tickdir','in')
%	load('color1.mat')	%Loads custom colormap used for 2D histo
 %   colormap(cmap)
%    colormap(jet(300))
   
	pos=get(gca,'Position');
% 	colormap(gca,parula)
	c=colorbar('manual');
	%set(c,'Position',[0.92 0.11 0.025 0.815])
	set(gca,'Position',[pos(1) pos(2) pos(3) pos(4)])
	set(c,'Position',[pos(1)+pos(3)*1.02 pos(2) pos(3)*0.05 pos(4)])
	set(get(c,'title'),'String','Counts/trace','fontsize',16,'fontweight','normal');
	caxis([0 0.5*MAX])
    cmap=flip(magma());
	colormap(gca,cmap);
end