%% Clear
clear
close all
clc
Nfiles = 0;

%% Settings
%path = 'C:\Users\dstefani\Google Drive\Measurements\davide\Matlab\Test\Test_data\scan160204_0\';
%path = 'D:\dstefani\Research\2017\Measurements in solution\Matthijs\OPE3NH2_DCM_1\3-7\';
%path = 'D:\dstefani\Research\2017\Peptide\MPA-2Ala-1Trp-1Cys\Sample 1\13-17\';
%path = 'D:\dstefani\Research\2017\Measurements in solution\OPE3-NH2 in methanol\Sample 1\1-5\';
%path = 'D:\dstefani\Research\2017\Measurements in solution\OPE3-NH2 in methanol\Sample 2\2-6\';
%path = 'D:\dstefani\Research\2017\Measurements in solution\OPE3-NH2 in acetonitrile\Sample 1\2-6\';
%path = 'H:\davide\OPE3-NH2 in ethanol\Sample 3\3-7\';
% path = 'H:\Chunwei\PCP3\Para_11\Molecule\Triangle\1-5\';
% path='E:\Data\Piezo_setup\OPE3\molecule\Triangle\14-20\';
 path='E:\Data\Piezo_setup\CyclophaneII\CP9_new\Triangle\15-19\3Hz\';
%path='E:\Data\Piezo_setup\Long_PCP3\old\PCP3\Para_11\Molecule\Triangle\1-5\';
path = strrep(path,'\','/');	%replaces backslashes with slashes in the path
filename = 'Self-Breaking-Triangle201012_5';	% 
Plots=struct();
Plots.SumUp =                   1;		%2D,1D,Jevo and settings
Plot.trace=                     1;    % Single traces
Plots.Hist1D =					1;		%1D histo
Plots.Hist2D_GT =               1;		%2D histo conductance vs time
Plots.Hist2D_GD =               0;    %2D histo conductance vs distance
Plots.JunctionEvolution =		0;		%Trace overview
Plots.G0Length =                0;		%1G_0 Length


RedoHisto = 0;	%
replot_trace=0;
Offset = 1;	% Offset correction of the data	!!WARNING!! This cannot be changed when loading a .mat file
Purge = 1;	% Remove traces with noise level above Purge_limit?
Purge_limit = 1e-6;	%	Traces with an offset higher than this will be removed from the data set
Restricted = 0; % Plot only a restricted subset of the data
Load = 0;	% Load a previus workspace, if present?
Save = 1;	% Save plots?
Close = 1;	% Close individual traces after saving them
savepath = [path filename '/'];

% mkdir moved after the check for the existence of the files
% if Save & ~exist(savepath,'dir')
% 	mkdir(savepath);
% end
%% Parameters
Vtodconversion = 0.3e-6;      % 1000V = 300um
attenuation = 0.03/300; % 0.04/300; %5e-5; %15e-5;  % attenuation factor		!!WARNING!! This cannot be changed when loading a .mat file
noiselvl = 1e-12;

%load('color1.mat')	%Loads custom colormap used for 2D histo
camp=flip(magma());

if Restricted
    plotstart = 1;
    plotend = 850;
    Nplotted = plotend-plotstart+1; %number of traces plotted
end

% tmin = -0.5; %nm
% tmax = 1.5; %nm
% Tbin = 310;
% Ymin = -7; %log10(5e-7); % for 5e-8 use Gmin = log10(5e-8);	-8
% Ymax = 1;
% binsperG = 30; %49;	%30
% Gbin = round((Ymax-Ymin)*binsperG);

tmin = -0.5; %s											%used for making histograms
tmax = 15; %s										%used for making histograms
binsperT =32; %46.5;%69.25;%37.75  38(0.04) ,43.25(0.035) 		%used for making histograms
Tbin = round((tmax-tmin)*binsperT);					%used for making histograms
Ymin = -8; %log10(5e-7); % log10(G0)				%used for making histograms
Ymax = 1; % log10(G0)									%used for making histograms
binsperG = 82;%30 ;									%used for making histograms
Gbin = round((Ymax-Ymin)*binsperG);					%used for making histograms
Tmin = -0.5; %s											%displayed in plots
Tmax = 15; %s												%displayed in plots
Gmin = 5e-7; % G0											%displayed in plots
Gmax = 3;	% G0											%displayed in plots
Dmin=1.5; % nm                                 %used for G-D histograms
Dmax=1.75; % nm                                 %used for G-D histograms
binsperD=32;													%used for G-D histograms
Dbin =round((Dmax-Dmin)*binsperD);     
%OptimizeBinningTriangle2(G,hist2D) % Run this function to optimize Dbin

tedges = linspace(tmin,tmax,Tbin);
dedges = linspace(Dmin,Dmax,Dbin);
yedges = 10.^linspace(Ymin,Ymax,Gbin);
hist2D = zeros(Gbin,Tbin);
hist2DGD=zeros(Gbin,Dbin);
hist1D = zeros(Gbin,1);


%% check if directory and files are there
if ~exist(path,'dir')
    disp('Folder not found')
    return
else
    if ~exist([path filename '_1.dat'],'file') && ~Load
        disp('Files not found')
        return
    elseif ~exist([savepath filename '.mat'], 'file') && Load
        disp('.mat file not found')
        return
    else
        if Save && ~exist(savepath,'dir')
            mkdir(savepath);
        end
        
    end
end

%% Load workspace or work the files
if Load && exist([savepath filename '.mat'], 'file')
	if ~RedoHisto
		%	load([path filename '.mat'], '-regexp', '^(?!path$|savepath$).') ;	% Does not load path and savepath in case it's loading from a different computer. To omit anothoer variable add |VARIABLE$
		load([savepath filename '.mat'], '-regexp', '^(?!path$|savepath$|Save$|Load$|RedoHisto$|Plots$).') ;	% Does not load path and savepath in case it's loading from a different computer. To omit anothoer variable add |VARIABLE$
		disp(['Loading data file ' filename '.mat']);
		disp([num2str(Nfiles) ' trace(s) found'])
	else
		%	load([path filename '.mat'], 'attenuation','G','motor','Nfiles','piezo','settings','set_voltage','speed') ;	% Does not load path and savepath in case it's loading from a different computer. To omit anothoer variable add |VARIABLE$
		load([savepath filename '.mat'], 'attenuation','G','motor','Nfiles','Offset','piezo','settings','set_voltage','set_voltage_corrected','speed') ;	% Only loads the sepcified variables
		disp(['Loading data file ' filename '.mat']);
		disp([num2str(Nfiles) ' trace(s) found']);
		disp('Making new histograms');
		%{
		%Doesn't work because 'settings' is missing
		% Converting G from cell to struct for compatibility with old data sets
		if  iscell(G)
			tmp = G;
			clear('G');
			G(Nfiles) = struct('t_breaking',[],'d_breaking',[],'g_breaking',[],'t_making',[],'d_making',[],'g_making',[]);
			for i=1:Nfiles
				G(i) = tmp{i};
			end
			settings = ' ';
			piezo = 1;
			motor = 0;
		end 
		%}
	end
elseif Nfiles == 0
	%% check number of runs
	if exist([path filename '_0.dat'],'file')
		counter = 0;
		k = 0;
	else
		counter = 1;
		k = 1;	% If the starting file is _1 and not _0, Nfiles = counter-1
	end
	
	while exist([path filename '_' num2str(counter) '.dat'],'file')
		counter = counter+1;
	end
	Nfiles = counter - k; %when exist fails, the loop ends and counter is not increased
	disp([num2str(Nfiles) ' file(s) found'])
	
	%% Get piezo/motor speed
	fid = fopen(strcat(path,filename,'_',num2str(k),'.dat'));
	filecontent = textscan(fid,'%s','delimiter','\n');
	filecontent = filecontent{:};
	startline = find(strncmp('@',filecontent,1));
	settings = filecontent(1:startline(1)-1);
	settings = regexprep(settings,'G0','G_0');
	%settings = char(settings);	% Not used anymore, so we can search
	%settings instead of filecontent
	piezoline = find(strncmp('Breaking speed 2', settings,16));
	motorline = find(strncmp('motor speed', settings,11));
	voltageline = find(strncmp('set voltage', settings,11));
	fclose(fid);
	
	if ~isempty(piezoline)
		piezo = 1;
		motor = 0;
		str = char(filecontent(piezoline));
		piezo_speed = sscanf(str,'Breaking speed 2 : %f');	% in V/s
		speed = piezo_speed*Vtodconversion;	% in m/s
		fprintf('Piezo speed found: %1.2f V/s\n',piezo_speed);
		str = char(filecontent(piezoline+1));
		making_speed = sscanf(str,'Making speed : %f');	% in V/s
		making_speed = making_speed*Vtodconversion;	% in m/s
	elseif ~isempty(motorline)
		motor = 1;
		piezo = 0;
		str = char(filecontent(motorline));
		motor_speed = sscanf(str,'motor speed : %f');	% in um/s
		speed = motor_speed * 1e-6;	% in m/s
		fprintf('Motor speed found: %1.2f um/s\n',motor_speed);
		making_speed = speed;
	else
       disp('File format not recognized (Not a breaking trace)')
	end
	
	try
		samplingline = find(strncmp('sampling rate', settings,13));
		str = char(settings(samplingline));
		sampling_rate = sscanf(str,'sampling rate = %f');	% in Hz
		points_per_nm = sampling_rate/(speed*attenuation*1e9);
	catch err
	end
	
   str = char(settings(voltageline));
   set_voltage = sscanf(str,'set voltage : %f');	% in V
   set_voltage_corrected = set_voltage;  % Fixing the bias offset
   fprintf('Set voltage found: %1.3f V\n',set_voltage_corrected);
    
	%% Importing data & Processing
	disp('Reading data'); % Otherwise it reads the data files
	G(Nfiles) = struct('t_breaking',[],'d_breaking',[],'g_breaking',[],'piezo_breaking',[],'t_making',[],'d_making',[],'g_making',[]);
	parfor i = 1:Nfiles
		disp(strcat(num2str(i),'/',num2str(Nfiles)))
		%Reads the whole file as a string and puts it into filecontent
		fid = fopen(strcat(path,filename,'_',num2str(i-1+k),'.dat'));	%if the starting file is _0, k=0 and i-1+k=0; if it's _1, k=1 and i-1+k=1
		filecontent = textscan(fid,'%s','delimiter','\n');
		filecontent = filecontent{:};
		%Gets the position of the character @
		startline = find(strncmp('@',filecontent,1));
		fclose(fid);
		tmp=regexp(filecontent(startline(1)+1),'\s*([\S]*)\s*');	% looks for whitespace(s) non-whitespace(s) (and separates them in bloc whitespace(s)
		cols = numel(tmp{1});	% number of columns in the file
		
		% Import breaking trace
		fid = fopen(strcat(path,filename,'_',num2str(i-1+k),'.dat'));
		if cols == 2
			data = textscan(fid,'%f %f','HeaderLines',startline(1)+1);  % Look for the pattern 'float float' skipping the startline+1 lines at the beginning of the file (headerlines)
		else
			data = textscan(fid,'%f %f %f','HeaderLines',startline(1)+1);  % Look for the pattern 'float float float' skipping the startline+1 lines at the beginning of the file (headerlines)
		end
		fclose(fid);
		
		% Creates struct for breaking data
		G(i).t_breaking = data{1};
      G(i).piezo_breaking=data{3};
		G(i).d_breaking = data{3}*0.3e-6*attenuation*1e9; % data file has time as x and it is here converted to displacement in nm (1e9 is for using nm)
		G(i).g_breaking = data{2} * set_voltage / (set_voltage_corrected); % S4c offset correction		
		% Offset correction
		if Offset
			offset = mean(G(i).g_breaking(end-100:end-50)); % calculates the offset with 200 points
			if Purge && offset > Purge_limit    % Discards traces that don't reach the noise level
				G(i).g_breaking(:) = noiselvl;
			else
				G(i).g_breaking = G(i).g_breaking-offset;
				G(i).g_breaking(G(i).g_breaking<noiselvl) = noiselvl;
			end
		else
			G(i).g_breaking = abs(G(i).g_breaking);
		end
		
		% Import making trace
		fid = fopen(strcat(path,filename,'_',num2str(i-1+k),'.dat'));
% 		data = textscan(fid,'%f %f','HeaderLines',startline(2)+1);
		data = textscan(fid,'%f %f %f','HeaderLines',startline(2)+1);
		fclose(fid);
		
		% Creates struct for making data %
		G(i).t_making = data{1};
		G(i).d_making = data{3}*0.3e-6*attenuation*1e9;
% 		G(i).d_making = data{3}*attenuation*1e9; % data file has time as x and it is here converted to displacement in nm (motor speed = 4um/s, attenuation = 8e-5, 1e9 is for using nm)
		G(i).g_making = data{2} * set_voltage / (set_voltage_corrected); % S4c offset correction
		
		% Offset correction
		if Offset
			G(i).g_making = G(i).g_making-offset;
		
 			G(i).g_making(G(i).g_making<noiselvl) = noiselvl;
			G(i).g_making = real(log10(abs(G(i).g_making)));
		end
	end
end

if ~Restricted
    plotstart = 1;
    plotend = Nfiles;
    Nplotted = Nfiles; %number of traces plotted
end

%% Breaking traces alignement & histo creation (done if a mat file is not loaded or by turning on RedoHisto = True)
IsMol=zeros(Nfiles,1);

if ~Load || (Load && RedoHisto)
    trace_hist = zeros(Gbin,Nfiles);
    disp(['Histograms include traces from ' num2str(plotstart) ' to ' num2str(plotend)])
	 parfor i = 1:Nfiles
		 try
            ind = find(G(i).g_breaking>3e-1,1,'last'); % zero displacement at run
            d0 = G(i).d_breaking(max(ind)); % finds the position for which G>0.3G_0 for the last time
            G(i).d_breaking = G(i).d_breaking-d0;   % shifts displacement so that it is 0 when G = 1G_0
				t0=G(i).t_breaking(max(ind));
				G(i).t_breaking = G(i).t_breaking-t0;
            
            %Creating 1D histo for individual traces (used in JunctionEvolution,
            %correlation histo, tunneling removal and subsets check)
            trace_hist(:,i) = sum(hist2(G(i).t_breaking,G(i).g_breaking, tedges, yedges),2);
        catch err
          end
          if (G(i).t_breaking(length(G(i).t_breaking(G(i).t_breaking>=0)))< tmax/6) || (mean(G(i).g_breaking(G(i).t_breaking>2))<2e-6)
              IsMol(i)=0;
          else
              IsMol(i)=i;
          end
	 end
    
	 parfor i = plotstart:plotend
		%Creating 2D histo
			hist2DGD=hist2DGD+ hist2(G(i).d_breaking,G(i).g_breaking,dedges,yedges);
        hist2D = hist2D + hist2(G(i).t_breaking,G(i).g_breaking, tedges, yedges);
	 end
	 
	 %Creating 1D histo
    hist1D = sum(hist2D,2);
    
    %Normalizing them both
    hist1D = hist1D/Nplotted;
    hist2D = hist2D/Nplotted;
	 hist2DGD=hist2DGD/Nplotted;
    
end
IsMol=nonzeros(IsMol); 

%% Saving workspace
%{
% Only sensible variables are saved, otherwise it's impossible to save or show other plots because loading the workspace overrides the settings
if exist('settings','var')
    save([path filename '.mat'], 'attenuation','Dbin','Tmax','Tmin','filename','G','Gbin','Gmax','Gmin','hist1D','hist2D','Nfiles','Nplotted','noiselvl','Offset','plotend','plotstart','set_voltage','settings','speed','Vtodconversion')	% saves selected variables in the folder with the raw data
else
    save([path filename '.mat'], 'attenuation','Dbin','Tmax','Tmin','filename','G','Gbin','Gmax','Gmin','hist1D','hist2D','Nfiles','Nplotted','noiselvl','Offset','plotend','plotstart','set_voltage','speed','Vtodconversion')	% saves selected variables in the folder with the raw data
    settings=[];
end
%}
if Save
	disp('Saving workspace')
   %	save([savepath filename '_' sprintf('%1.1f',set_voltage) 'V_' sprintf('%1.1f',speed*1e6) 'um_s.mat'])	% saves the whole workspace in the folder with the plots (not the one loaded)
   save([savepath filename '.mat'], '-v7.3')	% saves the whole workspace in the folder with the plots (not the one loaded)
end

%% One-look sum up
if Plots.SumUp ~= 0
	disp ('Plotting sum up');
	%	h=figure('PaperPosition',[0.6350 6.3500 20.3200 15.2400]);
	h=figure('PaperPositionMode','auto','Position',[150 100 1600 850]);
	h1=subplot(2,3,[1 4]);
	set(h1,'Position',[0.07 0.1 0.23 0.85])
	%plot_2DHist(hist2D);
	plot_2DHist_2(hist2D,'out',Tmin,Tmax,Gmin,Gmax,tedges,yedges);
	hold on
   xlabel('Time (s)')
	h2=subplot(2,3,2);
	plot_1DHist(hist1D);
	set(h2,'Position',[0.425 0.6 0.25 0.35])
	h3=subplot(2,3,5);
	set(h3,'Position',[0.425 0.11 0.25 0.35])
	plot_Junction_evo(trace_hist);
   v = [0 min(yedges); plotstart min(yedges); plotstart max(yedges); 0 max(tedges); plotend min(yedges); Nfiles min(yedges); Nfiles max(yedges); plotend max(tedges)];
   f = [1 2 3 4
      5 6 7 8];
   patch('Faces',f,'Vertices',v,'EdgeColor','none','FaceColor',[0.5 0.5 0.5],'FaceAlpha',.6);
   line([plotstart plotstart],ylim, 'Color','g');
	line([plotend plotend],ylim, 'Color','g');
	h4=subplot(2,3,[3 6]);
	set(gca,'visible','off');	%removes axis
	str = char(filename);
	str = strrep(str,'_','\_');	% prevents the underscore from being interpreted as subscript
	info = {['Data set: ' str],['Date: ' str(9:10) '/' str(7:8) '/' str(5:6)],[num2str(Nfiles) ' traces'],'',...
		 char(settings),...
		 '',...
		 ['Attenuation: ' sprintf('%1.1e',attenuation)],...
		 ['Plotted range: ' num2str(plotstart) '-' num2str(plotend)],...
		 ['Offset correction: ' num2str(Offset)],...
		 '',...
		 sprintf('Dbin: %i',Tbin),...
		 sprintf('binsperG: %i',binsperG),...
		 %	sprintf('Gbin: %i',Gbin),...
		 %		'Notes: Bare Au',...
		 };

	% Adds the "Points per nm: " line after "Attenuation: "
	if exist('sampling_rate','var')
		idx = find(ismember(info, ['Attenuation: ' sprintf('%1.1e',attenuation)]));
		for i = numel(info):-1:idx-1
			info{i+1} = info{i};
		end
		info{idx-1} = (['Points per nm: ' sprintf('%1.1f',points_per_nm)]); 
	 end

	annotation('textbox',[0.75 0.11 0.20 0.85],...
		 'String',info,...
		 'FontSize',14,...
		 'FontName','Arial',...
		 'BackgroundColor',[1 1 1],...
		 'Tag' , 'somethingUnique');

	set(gcf,'Position',[150 100 1600 850])
	set(findall(gcf,'type','text'),'fontsize',17,'fontweight','normal')
	drawnow()
   if Save == 1
      if piezo
         if ~exist('piezo_speed','var')
            piezo_speed = sscanf(char(settings(7,:)),'Breaking speed 2 : %f');
         end
         if Restricted
            saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',piezo_speed) 'V_s_[' num2str(plotstart) '-' num2str(plotend) ']_advanced.png'])
         else
            saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',piezo_speed) 'V_s_advanced.png'])
         end
      end
      if motor
         if Restricted
            saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',motor_speed) 'um_s_[' num2str(plotstart) '-' num2str(plotend) ']_advanced.png'])
         else
            saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',motor_speed) 'um_s_advanced.png'])
         end
      end
   end

	%# delete the annotation
	delete(findall(gcf,'Tag','somethingUnique'))

	info = {['Data set: ' str],['Date: ' str(9:10) '/' str(7:8) '/' str(5:6)],[num2str(Nfiles) ' traces'],'',...
		 ['Attenuation: ' sprintf('%1.1e',attenuation)],...
		 ['Traces plotted: ' num2str(plotstart) '-' num2str(plotend)],...
       ['Bias V: ' sprintf('%1.3f',set_voltage_corrected) ' V'],...
		 ['Piezo Speed: ' sprintf('%1.1f',speed/Vtodconversion) ' V/s'],...
		 ['Electrode Speed: ' sprintf('%1.1f',speed*attenuation*1e9) ' nm/s'],...
		 %['Sampling Rate: ' sprintf('%1.1f',sampling_rate) ' Hz'],...
		 %		'Notes: Bare Au',...
		 };
	annotation('textbox',...
		 [0.75 0.11 0.20 0.85],...
		 'String',info,...
		 'FontSize',14,...
		 'FontName','Arial',...
		 'BackgroundColor',[1  1 1],...
		 'Tag' , 'somethingUnique');

	set(gcf,'Position',[150 100 1600 850])
	set(findall(gcf,'type','text'),'fontsize',17,'fontweight','normal')
   if Save == 1
        if piezo
            if Restricted
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',piezo_speed) 'V_s_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            else
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',piezo_speed) 'V_s.png'])
            end
        end
        if motor
            if Restricted
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',motor_speed) 'um_s_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            else
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',motor_speed) 'um_s.png'])
            end
        end
   end
end
%}

%% Plot single traces
if Plot.trace == 1
   disp('Plotting single traces');
   parfor i=1:Nfiles
      disp(strcat(num2str(i),'/',num2str(Nfiles)))
      if ~exist([savepath 'Single_Trace/' filename '_' num2str(i) '.png'],'file') || replot_trace
         if nnz(G(i).g_breaking <1) / numel(G(i).g_breaking) > 0.01  % don't plot traces that have less than 1% of points below 1 G0
            f=figure;
%             set(gcf,'Visible','on','Position',[1 41 1920 964]);
            
            %yyaxis left
            semilogy(G(i).t_breaking,G(i).g_breaking,'Linewidth',0.5)
            ylabel('Conductance [G_0]');
            set(gca,'Ylim',[5e-8 3])
            
            %If you want to plot the piezo voltage (Remember to uncomment G(i).piezo_blinking in data input)
            yyaxis right
            plot(G(i).t_breaking,G(i).piezo_breaking,'Linewidth',0.5);
            title(['Trace ' num2str(i)])
            xlabel('Time [s]');
            ylabel('Piezo Voltage (V)')
            %set(gca,'Xlim',[-0.5 600])
            %set(gca,'Xlim',[min(tedges) max(tedges)])
            %set(gcf, 'Position', [200 75 1500 900])
            
            if Save
					if ~exist([savepath 'Single_Trace/'],'dir')
						mkdir([savepath 'Single_Trace/']);
						mkdir([savepath 'Single_Trace/fig/']);
					end
					saveas(f,[savepath 'Single_Trace/' filename '_' num2str(i) '.png'])
               saveas(f,[savepath 'Single_Trace/fig/' filename '_' num2str(i) '.fig'])
            end
%             waitforbuttonpress
            close(f)
            %{
      semilogy(G(i).t_blinking,G(i).g_blinking);
      hold on;
      semilogy(G(i).t_making + G(i).t_blinking(end),G(i).g_making);
      title(['Trace ' num2str(i)])
      xlabel('Time [s]');
      ylabel('Conductance [G_0]');
      %  set(gca,'Xlim',[-0.2 .5])
      set(gca,'Ylim',[5e-8 10])
      hold off;
      if Save
         saveas(f,[savepath filename '_' num2str(i) '_whole.png'])
      end
            %}
         else
            disp('Not enough points below 1 G_0')
            
         end
      end
   end
   
end

%% 1D histogram
if Plots.Hist1D == 1
    disp('Plotting 1D Histogram');
    
    h = figure('Position',[300 150 1100 775],'PaperPositionMode','auto');
    plot_1DHist(hist1D);
    
    %  	pos1 = find(min(abs(yedges - 3)) == abs(yedges - 3));
    %  	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
    %  	MAX = max(hist1D(pos2:pos1));
    %
    % 	h = figure;
    % 	semilogx(yedges,hist1D);
    % 	xlabel('Conductance [G_0]')
    % 	ylabel('Counts/trace')
    % 	set(gca,'fontsize',20,'fontweight','normal')
    % 	set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
    % 	set(gca,'linewidth',1.5,'box','on')
    % 	set(gcf,'color','white')
    % 	set(gca,'Xlim',[10^Gmin  3])
    % 	set(gca,'Ylim',[0 1.05*MAX])
    % 	set(gca,'XTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
    % 	%set(gca,'XTick',[1e-8 1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
    
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_G_1D_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_G_1D_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
        else
            saveas(h,[savepath filename '_G_1D.png'])
            saveas(h,[savepath filename '_G_1D.fig'])
        end
    end
    
end

%% 2D histogram
if Plots.Hist2D_GT == 1
   disp('Plotting 2D Histogram');
   
% 	h = figure('Position',[500 150 600 850],'PaperPositionMode','auto');
% 	axes('Position',[0.17 0.11 0.62 0.815]);
	%h = figure('Position',[500 150 600 800],'PaperPositionMode','auto');
	%axes('Position',[0.17 0.11 0.72 0.815]);
   %plot_2DHist_2(hist2D,'north',Tmin,Tmax,Gmin,Gmax);
	%plot_2DHist_2(hist2D,'east',Tmin,Tmax,Gmin,Gmax);
   
   h = figure('Position',[500 150 600 750],'PaperPosition',[0.6 5 16 20],'PaperPositionMode','auto');
   plot_2DHist_2(hist2D,[],Tmin,Tmax,Gmin,Gmax,tedges,yedges);
   xlabel('Time(s)')
	
	 % 	%Normalize histogram so that the best constrast is between 1e-3 and 1e-6
    % 	pos1 = find(min(abs(yedges - 1e-3)) == abs(yedges - 1e-3));
    % 	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
    % 	MAX = max(max(hist2D(pos2:pos1,:)))/2;
    %
    % 	h = figure('PaperPosition',[0.6 5 16 20]);
    % 	%surf(tedges,yedges,hist2D,'edgecolor','none');
    %   	surf(tedges,yedges,hist2D,'edgecolor','interp');	% If you are importing data that was plotted with a different Dbin you have to recreate the 2D histogram by initializing it and running the 'Breaking traces alignement & histo creation' segment
    % 	view([0 90])
    % 	% axis([-0.5,2,10.^-6.1,10.^0.5]) %2D histo
    % 	c=colorbar;%('Position',[0.915 0.16 0.03 0.7]);
    % 	title(c,'Counts/trace')
    % 	set(gca,'YScale','log')
    % 	xlabel('Electrode displacement [nm]')
    % 	ylabel('Conductance [G_0]')
    % 	%title('Bare Au')
    % 	set(gca,'fontsize',20,'fontweight','normal')
    % 	set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
    % 	set(gca,'linewidth',2,'box','on')
    % 	set(gcf,'color','white')
    % 	set(gca,'Xlim',[-0.5 2])
    % 	set(gca,'Ylim',[10^Gmin 3])
    % 	set(gca,'YTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
    % 	%set(gca,'YTick',[1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
    % 	set(gca,'Tickdir','in')
    % 	set(gcf,'Position',[500 150 600 750])
    % 	colormap(cmap)
    % 	caxis([0 MAX])
    %     ch = get(c,'YLabel'); % Handle of the x label
    %     %pause(0.2)	% If I remove this the colorbar comes out wrong...
    %     colormap(c,cmap)	%... so I have to reset it
    %     set(ch, 'Units', 'Normalized')
    %     %pos = get(ch, 'Position');
    %     set(ch,'Position',[2.75 0.5])	% These values were based on the pos of the line above
    
    
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_G_2D_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_G_2D_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
        else
            saveas(h,[savepath filename '_G_2D.png'])
            saveas(h,[savepath filename '_G_2D.fig'])
        end
    end
    
end

%% 2D histogram GD
if Plots.Hist2D_GD == 1
   disp('Plotting 2D Histogram');
   
% 	h = figure('Position',[500 150 600 850],'PaperPositionMode','auto');
% 	axes('Position',[0.17 0.11 0.62 0.815]);
	%h = figure('Position',[500 150 600 800],'PaperPositionMode','auto');
	%axes('Position',[0.17 0.11 0.72 0.815]);
   %plot_2DHist_2(hist2D,'north',Tmin,Tmax,Gmin,Gmax);
	%plot_2DHist_2(hist2D,'east',Tmin,Tmax,Gmin,Gmax);
   
   h = figure('Position',[500 150 600 750],'PaperPosition',[0.6 5 16 20],'PaperPositionMode','auto');
   plot_2DHist_2(hist2DGD,[],Dmin,Dmax,Gmin,Gmax,dedges,yedges);
   xlabel('Displacement(nm)')
	
	 % 	%Normalize histogram so that the best constrast is between 1e-3 and 1e-6
    % 	pos1 = find(min(abs(yedges - 1e-3)) == abs(yedges - 1e-3));
    % 	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
    % 	MAX = max(max(hist2D(pos2:pos1,:)))/2;
    %
    % 	h = figure('PaperPosition',[0.6 5 16 20]);
    % 	%surf(tedges,yedges,hist2D,'edgecolor','none');
    %   	surf(tedges,yedges,hist2D,'edgecolor','interp');	% If you are importing data that was plotted with a different Dbin you have to recreate the 2D histogram by initializing it and running the 'Breaking traces alignement & histo creation' segment
    % 	view([0 90])
    % 	% axis([-0.5,2,10.^-6.1,10.^0.5]) %2D histo
    % 	c=colorbar;%('Position',[0.915 0.16 0.03 0.7]);
    % 	title(c,'Counts/trace')
    % 	set(gca,'YScale','log')
    % 	xlabel('Electrode displacement [nm]')
    % 	ylabel('Conductance [G_0]')
    % 	%title('Bare Au')
    % 	set(gca,'fontsize',20,'fontweight','normal')
    % 	set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
    % 	set(gca,'linewidth',2,'box','on')
    % 	set(gcf,'color','white')
    % 	set(gca,'Xlim',[-0.5 2])
    % 	set(gca,'Ylim',[10^Gmin 3])
    % 	set(gca,'YTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
    % 	%set(gca,'YTick',[1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
    % 	set(gca,'Tickdir','in')
    % 	set(gcf,'Position',[500 150 600 750])
    % 	colormap(cmap)
    % 	caxis([0 MAX])
    %     ch = get(c,'YLabel'); % Handle of the x label
    %     %pause(0.2)	% If I remove this the colorbar comes out wrong...
    %     colormap(c,cmap)	%... so I have to reset it
    %     set(ch, 'Units', 'Normalized')
    %     %pos = get(ch, 'Position');
    %     set(ch,'Position',[2.75 0.5])	% These values were based on the pos of the line above
    
    
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_G_2DGD_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_G_2DGD_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
        else
            saveas(h,[savepath filename '_G_2DGD.png'])
            saveas(h,[savepath filename '_G_2DGD.fig'])
        end
    end
    
end

%% Junction evolution
if Plots.JunctionEvolution == 1
    disp('Plotting junction evolution');
    
    f = figure('Position',[450 150 1100 775],'PaperPositionMode','auto');
    plot_Junction_evo(trace_hist);
    
    
    % 	tracenum = 1:Nfiles;
    %
    % %JunctionEvolution is obsolete, trace_hist is ideally identical to JunctionEvolution (small
    % % differences due to the different filling method)
    % %	JunctionEvolution = zeros(Gbin,Nfiles);
    % %	for i = 1:Nfiles
    % %		JunctionEvolution(:,i) = hist(G(i).g_breaking,yedges);
    % %	end
	 
	 % % Convert any 1D histo in a paper-ready figure
    % 	pos1 = find(min(abs(yedges - 3)) == abs(yedges - 3));
    %  	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
    %  	MAX = max(max(trace_hist(pos2:pos1,:)));
    %
    % 	h = figure;
    % 	surf(tracenum,yedges,trace_hist,'LineStyle','none');	% 'LineStyle','none' removes the grid over which the surface is plotted, preventing the plot to show as all black when too dense
    % 	set(gca,'YScale','log')
    % 	view([0 90])
    % 	xlabel('Trace number');
    % 	ylabel('Conductance [G_0]');
    % 	set(gca,'fontsize',22,'fontweight','normal')
    % 	set(findall(gcf,'type','text'),'fontsize',22,'fontweight','normal')
    % 	set(gca,'linewidth',0.5,'box','on')
    % 	set(gcf,'color','white')
    % 	set(gca,'Xlim',[1 Nfiles])
    % 	set(gca,'Ylim',[10^Gmin 3])
    % 	set(gca,'YTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
    % 	set(gca,'Tickdir','in')
    % 	%colormap(linspecer)
    % 	%colormap(cmap)
    % 	c=colorbar;
    % 	ylabel(c,'Counts/trace')
    % 	caxis([0 0.5*MAX])
    
    if Save == 1
        saveas(f,[savepath filename '_Junction_evo.png'])
        saveas(f,[savepath filename '_Junction_evo.fig'])
    end
    
    %Two vertical green lines show the traces included in the histograms
    line([plotstart plotstart],ylim, 'Color','g');
    line([plotend plotend],ylim, 'Color','g');
    
    
end