function plot_2DHist_2(hist2D,cbar,Dmin,Dmax,Gmin,Gmax,xedges,yedges)
	
% function plot_2DHist2_2(hist2D,paper,cbar,Dmin,Dmax,Gmin,Gmax)
% if ~exist('paper','var') || isempty(paper)
%   paper = 0;
% end
	if ~exist('cbar','var') || isempty(cbar)
		cbar = 0;
	end
	if nargin< 7
			xedges = evalin('base','xedges');
			yedges = evalin('base','yedges');
	end
	if ~exist('Dmin','var') || isempty(Dmin)
     Dmin=min(xedges);
	end
	if ~exist('Dmax','var') || isempty(Dmax)
     Dmax=max(xedges);
	end
	if ~exist('Gmin','var') || isempty(Gmin)
		Gmin=min(yedges);
	end
	if ~exist('Gmax','var') || isempty(Gmax)
		Gmax=max(yedges);
	end
	
	
	pos1 = find(min(abs(yedges - 1e-3)) == abs(yedges - 1e-3));
	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
	MAX = max(max(hist2D(pos2:pos1,:)))/2;

  	surf(xedges,yedges,hist2D,'edgecolor','interp');	% If you are importing data that was plotted with a different Dbin you have to recreate the 2D histogram by initializing it and running the 'Breaking traces alignement & histo creation' segment 
	view([0 90])
	set(gca,'YScale','log')

	xlabel('Electrode displacement [nm]')
	ylabel('Conductance [G_0]')
	%title('Bare Au')
	set(gca,'fontsize',20,'fontweight','normal')
	set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
	set(gca,'linewidth',1,'box','on');
	set(gca,'Tickdir','in','Layer','top','XGrid','off','YGrid','off')
	set(gcf,'color','white')
	set(gca,'Xlim',[Dmin Dmax])
   %set(gca,'Xlim',[-0.5 2.5])
	set(gca,'Ylim',[Gmin Gmax])
	%set(gca,'Ylim',[5e-7 3])
	%set(gca,'YTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
	set(gca,'YTick',[1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
%	load('mycmap.mat')
%    load('color1.mat')	%Loads custom colormap used for 2D histo
%    colormap(cmap)
%    colormap(mycmap2)
    cmap=flip(magma());
	colormap(gca,cmap)
    caxis([0 MAX])
    
    if strcmp(cbar,'north')
        c=colorbar('north');	% 'east' 'north'
        drawnow; % if the colorbar is not drawn at this point the tick labels end above the bar
        set(c,'Position',[0.425 0.84 0.45 0.035]); % for 'north'
        set(get(c,'title'),'String','Counts/trace','fontsize',16,'fontweight','normal');
    elseif strcmp(cbar,'east')
        c=colorbar('east');	% 'east' 'north'
        drawnow; % if the colorbar is not drawn at this point the tick labels end above the bar
        set(c,'Position',[0.775 0.525 0.04 0.35]); % for 'east'
        set(get(c,'title'),'String','Counts/trace','fontsize',16,'fontweight','normal');
    elseif strcmp(cbar,'out')
        c=colorbar('Position',[0.305 0.1 0.01667 0.85]);
    elseif strcmp(cbar,'coupled')
        pos = get(gca,'Position');
        c=colorbar('Location','manual');
        set(gca,'Position',[pos(1) pos(2) pos(3) pos(4)]);
        set(c,'Position',[pos(1)+pos(3)*1.05 pos(2) pos(3)*0.1 pos(4)]);
    else
        c=colorbar;%('Position',[0.915 0.16 0.03 0.7]);
        set(gcf,'Position',[500 100 640 850])
    end
    

	
%  	if nargout > 0
%  		plot2D = get(gco);
%  	end
end
